//*************************************************************
//       Huuto.net työkalu / esimerkki API:N käytöstä         *
//                                                            *
//           Tupla kohteiden etsiminen avoimista              *
//                                                            *
//              Lazarus 1.6.4 (vain Windows)                  *
//                                                            *
//               Viimeksi muokattu 30.06-2017                 *
//                                                            *
//                  Email: info@pilvet.fi                     *
//                  Web: http://pilvet.fi                     *
//*************************************************************

unit Unit1;

{$MODE Delphi}

interface

uses
  Windows, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Comobj, Grids, ExtCtrls, Shellapi, LazUTF8;

type

  { TForm1 }

  TForm1 = class(TForm)
    tyyppi: TComboBox;
    sg: TStringGrid;
    edistyminen: TPanel;
    Panel2: TPanel;
    Label2: TLabel;
    user: TEdit;
    categoryid: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    SaveDialog1: TSaveDialog;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    function kopioi_alkaen(source: string; alkaen: integer): string;
    function onkoennestaan(kohde, otsikko: string): integer;
    function onkojo(s: string): boolean;
    procedure avaalinkki(linkki: string);
    procedure SortGrid;
    procedure Button2Click(Sender: TObject);
    procedure sgDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
    procedure sgDblClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure categoryidExit(Sender: TObject);
  end;

const
  osoite = 'https://api.huuto.net/1.1/';
  palvelin = 'https://www.huuto.net/';
var
  Form1: TForm1;
  pysayta: boolean;
  httpreq: variant;
  id, title: array of string;
  laskuri: integer;
  nocache: string;
implementation

{$R *.lfm}

procedure TForm1.SortGrid;
var i, j, prev2: integer;
    prev: string;
    taulu: array of string;
    taulu2: array of integer;
    taulu3: array of array of string;
begin
 if sg.rowcount<3 then exit;
 setlength(taulu, sg.rowCount);
 setlength(taulu2, sg.rowCount);
 setlength(taulu3, sg.colCount, sg.rowCount);
 for j:=1 to sg.rowCount-1 do
  begin
   taulu[j]:=ansilowercase(sg.Cells[1,j]);
   taulu2[j]:=j;
  end;
  for i:=1 to sg.rowcount-2 do
   for j:=1+i to sg.rowcount-1 do
   begin
    if (taulu[i]>taulu[j]) then
    begin
     prev:=taulu[i];
     taulu[i]:=taulu[j];
     taulu[j]:=prev;
     prev2:=taulu2[i];
     taulu2[i]:=taulu2[j];
     taulu2[j]:=prev2;
    end;
   end;
  for i:=0 to sg.colcount-1 do
   for j:=1 to sg.rowCount-1 do
    taulu3[i,j]:=sg.cells[i,j];
  for i:=0 to sg.colcount-1 do
   for j:=1 to sg.rowCount-1 do
    sg.cells[i,j]:=taulu3[i, taulu2[j]];
end;

function HTTPEncode(const AStr: String): String;
const NoConversion = ['A'..'Z','a'..'z','*','@','.','_','-','0'..'9','$','!','''','(',')'];
var Sp, Rp: PChar;
begin
  SetLength(Result, Length(AStr)*3);
  Sp:=PChar(AStr);
  Rp:=PChar(Result);
  while Sp^<>#0 do
  begin
    if Sp^ in NoConversion then Rp^:=Sp^
    else
     if Sp^=' ' then Rp^:='+'
     else
     begin
      FormatBuf(Rp^, 3, '%%%.2x', 6, [Ord(Sp^)]);
      Inc(Rp,2);
     end;
    Inc(Rp);
    Inc(Sp);
  end;
  SetLength(Result, Rp-PChar(Result));
end;

function httpget(fileURL: string): string;
var StartedTime, aika: DWord;
    URL: Olevariant;
begin
 result:='';
 aika:=20000; // aikakatkaisu 20 sekuntia
 URL:=fileURL;
 StartedTime:=GetTickCount;
 try
  httpreq.open('GET', URL, true);
  httpreq.setRequestHeader('Content-type', 'text/html');
  httpreq.send();
  while (httpreq.readystate<>4) and (GetTickCount<startedtime+aika) and (pysayta=false) do
   begin application.processmessages; sleep(10); end;
  if (GetTickCount>=startedtime+aika) or (pysayta=true) then
  begin
   httpreq.abort;
   exit;
  end;
  if (httpreq.status=200) or (httpreq.status=0) then result:=httpreq.responsetext;
 except
  httpreq.abort;
 end;
end;

function TForm1.kopioi_alkaen(source: string; alkaen: integer): string;
begin
 result:=copy(source, alkaen, length(source)-alkaen+1);
end;

procedure TForm1.avaalinkki(linkki: string);
var s: pansichar;
begin
 s:=pchar(linkki);
 ShellExecute(Handle, 'open', s, nil, nil, SW_SHOWNORMAL);
end;

function TForm1.onkoennestaan(kohde, otsikko: string): integer;
var i, l: integer;
begin
 result:=-1;
 l:=length(id);
 for i:=0 to l-1 do
  if kohde=id[i] then exit;
 for i:=0 to l-1 do
  if otsikko=title[i] then
  begin
   result:=i;
   //exit;
  end;
 l:=l+1;
 setlength(id, l);
 setlength(title, l);
 id[l-1]:=kohde;
 title[l-1]:=otsikko;
end;

function TForm1.onkojo(s: string): boolean;
var i: integer;
begin
 result:=false;
 for i:=1 to sg.rowcount-1 do
  if sg.cells[0,i]=s then
  begin
   result:=true;
   exit;
  end;
end;

procedure tarkista(s: string);
const lainausmerkki: char=#27; //escapechar
var s2, itemid, otsikko: string;
i, paikka, cc, loytyi: integer;
begin
 i:=ansipos(',{"links":', ansilowercase(s));
 while i>0 do
 begin
  s:=form1.kopioi_alkaen(s, i+10);
  i:=ansipos(',{"links":', ansilowercase(s));
  if i=0 then i:=length(s);
  s2:=copy(s, 1, i-1);
  paikka:=ansipos('items/', s2);
  itemid:=form1.kopioi_alkaen(s2, paikka+6);
  itemid:=copy(itemid, 1, 9); // 9numeroinen itemid
  i:=ansipos('"title":"', ansilowercase(s2));
  s2:=form1.kopioi_alkaen(s, i+9);
  i:=ansipos('"', s2);
  otsikko:=copy(s2, 1, i-1);
  otsikko:=stringreplace(otsikko,lainausmerkki,'"',[rfreplaceall]);
  loytyi:=form1.onkoennestaan(itemid, otsikko);
  if loytyi>-1 then
  begin
   laskuri:=laskuri+1;
   cc:=form1.sg.rowcount;
   if form1.sg.cells[0,1]<>'' then cc:=cc+1;
   if form1.onkojo(id[loytyi])=false then
   begin
    form1.sg.rowcount:=cc;
    form1.sg.cells[0,cc-1]:=id[loytyi];
    form1.sg.cells[1,cc-1]:=WinCPToUTF8(title[loytyi]);
   end else cc:=cc-1;
   if form1.onkojo(itemid)=false then
   begin
    cc:=cc+1;
    form1.sg.rowcount:=cc;
    form1.sg.cells[0,cc-1]:=itemid;
    form1.sg.cells[1,cc-1]:=WinCPToUTF8(otsikko);
   end;
  end;
  //Seuraava
  i:=ansipos(',{"links":', ansilowercase(s));
 end;
end;

function JsonUnescape(const s: AnsiString): WideString;
const lainausmerkki: char=#27; //escapechar
var i, j, c: Integer;
begin
 SetLength(Result, Length(s));
 i:=1;
 j:=1;
 while i<=Length(s) do
 begin
  if (s[i]='\') and (i<Length(s)) then
  begin
   if (s[i+1]='\') or (s[i+1]='/') then
   begin
    Result[j]:=WideChar(s[i+1]);
    inc(i, 2);
   end
   else if (s[i+1]='"') then
   begin
    Result[j]:=WideChar(lainausmerkki);
    inc(i, 2);
   end
   else if (s[i+1]='r') then
   begin
    Result[j]:=WideChar(#13);
    inc(i, 2);
   end
   else if (s[i+1]='n') then
   begin
    Result[j]:=WideChar(#10);
    inc(i, 2);
   end
   else if (s[i+1]='t') then
   begin
    Result[j]:=WideChar(#9);
    inc(i, 2);
   end
   else if (s[i+1]='u') and (i+5<=Length(s)) and TryStrToInt('$'+string(Copy(s, i+2, 4)), c) then
   begin
    inc(i, 6);
    Result[j]:=WideChar(c);
   end
   else
   begin
    Result[j]:=WideChar(s[i]); //ei virhettä
    inc(i);
   end;
  end
  else
  begin
   Result[j]:=WideChar(s[i]);
   inc(i);
  end;
  inc(j);
 end;
 SetLength(Result, j-1);
end;

procedure haekohteet;
var url, s: string;
sivu: integer;
begin
 sivu:=1;
 url:=osoite+'items?sellernro='+HTTPEncode(WinCPToUTF8(form1.user.text));
 if form1.categoryid.text<>'' then url:=url+'&category='+form1.categoryid.text;
 url:=url+'&status=open&limit=50&sort=closingTime&page=';
 while true do
 begin
  form1.edistyminen.Caption:='Haetaan sivua '+inttostr(sivu);
  application.ProcessMessages;
  s:=httpget(url+inttostr(sivu)+'&nocache='+nocache);
  s:=JsonUnescape(s);
  s:=stringreplace(s, '"items":[', '"items":,', [rfreplaceall, rfignorecase]);
  if ansipos('{"links":', s)=0 then break;
  tarkista(s);
  sivu:=sivu+1;
 end;
end;

function httppost(httpreq: variant; const fileURL: string; hnames, hvalues: array of string; aika: dword; strPostData: string): string;
var startedtime: DWord;
    PostData, URL, n, v: Olevariant;
    i: Integer;
begin
 result:='';
 URL:=fileURL;
 try
 PostData:=VarArrayCreate([0, Length(strPostData)-1], varByte);
 for i:=1 to Length(strPostData) do PostData[i-1]:=Ord(strPostData[i]);
 startedTime:=GetTickCount;
 httpreq.open('POST', URL, true);
 for i:=0 to length(hnames)-1 do
 begin
  n:=hnames[i];
  v:=hvalues[i];
  httpreq.setRequestHeader(n, v);
 end;
 httpreq.send(PostData);
 while (httpreq.readystate<>4) and (GetTickCount<startedtime+aika) do
   begin application.processmessages; sleep(10); end;
 if (GetTickCount>=startedtime+aika) then
  begin
   httpreq.abort;
   exit;
  end;
 result:=httpreq.responsetext;
 except end;
end;

function tunnuksestaid(tunnus: string): string;
var data, strpostdata: string;
    i, tmp: integer;
begin
 result:='';
 strpostdata:='status=N&addtime=0&closingtime=0&sellstyle=all&seller_type=C&seller='+tunnus;
 // www kautta
 data:=httppost(httpreq, 'https://www.huuto.net/haku', ['Content-Type'], ['application/x-www-form-urlencoded'], 20000, strpostdata);
 tmp:=ansipos('/haku/sellernro/', data);
 if tmp>0 then
 begin
  data:=copy(data, tmp+16, 8); //max 8-merkkinen idnro
  for i:=1 to length(data) do
   if data[i] in ['0'..'9'] then result:=result+data[i] else break;
 end;
end;

function kokonaisluvuksi(source: string): integer;
var errorpos: integer;
begin
 val(source, result, errorpos);
 if errorpos<>0 then result:=-1;
end;

procedure TForm1.Button1Click(Sender: TObject);
var i: integer;
    nimimerkki: string;
begin
 if tyyppi.itemindex=0 then
 begin
  if kokonaisluvuksi(user.text)<1 then
  begin
   showmessage('Käyttäjän ID numero täytyy olla luku!');
   exit;
  end;
 end
 else
 begin
  if user.text='' then
  begin
   showmessage('Anna käyttäjän nimimerkki!');
   exit;
  end;
  nimimerkki:=tunnuksestaid(user.text);
  if nimimerkki='' then
  begin
   showmessage('Käyttäjää ei löytynyt!');
   exit;
  end;
  user.text:=nimimerkki;
  tyyppi.itemindex:=0;
 end;
 pysayta:=false;
 button3.Enabled:=false;
 edistyminen.Caption:='';
 edistyminen.Top:=(form1.Height div 2)-edistyminen.Height div 2;
 edistyminen.left:=(form1.Width div 2)-edistyminen.Width div 2;
 edistyminen.Visible:=true;
 laskuri:=0;
 setlength(id, 0);
 setlength(title, 0);
 for i:=1 to sg.RowCount-1 do
 begin
  sg.Cells[0,i]:='';
  sg.Cells[1,i]:='';
 end;
 sg.RowCount:=2;
 Haekohteet;
 edistyminen.Visible:=false;
 if laskuri=0 then showmessage('Samannimisiä kohteita ei löytynyt!') else
 begin
  sortgrid;
  showmessage('Avoimia, joilla oli sama nimi löytyi '+inttostr(laskuri)+'kpl'+#13#10#13#10+'Kohteita voi avata selaimessa tuplaklikkaamalla.');
  button3.Enabled:=true;
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 randomize;
 nocache:=inttostr(random(1000000)); // vältetään IE:n välimuisti seuraavalla kerralla
 httpreq:=CreateOleObject('MSXML2.XMLHTTP.6.0');
 pysayta:=false;
 setlength(id,0);
 setlength(title,0);
 sg.Cells[0,0]:='Kohdenumero';
 sg.Cells[1,0]:='Kohteen nimi';
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 pysayta:=true;
 edistyminen.Visible:=false;
end;

procedure TForm1.sgDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
const tausta1=$00fefefe;
      tausta2=$00fff4ec;
      tausta3=Clskyblue;
begin
 if (aRow=0) then sg.Canvas.Brush.Color:=$00cbb3a2
 else
 if (sg.colcount>1) then
 begin
  if aRow mod 2=0 then sg.Canvas.Brush.Color:=tausta1 else sg.Canvas.Brush.Color:=tausta2;
 end;
 if (arow=sg.Row) and (acol=sg.col) and (sg.cells[1, sg.Row]<>'') then sg.Canvas.Brush.Color:=tausta3;
 sg.Canvas.FillRect(Rect);
 sg.Canvas.font.color:=clblack; sg.Canvas.font.style:=[];
 sg.Canvas.Textout(Rect.Left+2, Rect.Top+0, sg.cells[acol, arow]);
end;

procedure TForm1.sgDblClick(Sender: TObject);
begin
 if (sg.row>0) and (length(sg.Cells[0, sg.Row])>3) then
  avaalinkki(palvelin+'kohteet/'+sg.Cells[0, sg.Row]);
end;

function CreateHTML: string;
var tmp: string;
i,j: integer;
begin
 result:='<HTML>'+#13#10+'<HEAD>'+#13#10;
 result:=result+'<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=windows-1252">'+#13#10+'<TITLE></TITLE>'+#13#10;
 result:=result+'</HEAD>'+#13#10+'<BODY>'+#13#10+'<TABLE BORDER=1 CELLPADDING=2 CELLSPACING=3>'+#13#10;
 for j:=0 to form1.sg.rowcount-1 do
 begin
  result:=result+'<TR>'+#13#10;
  for i:=0 to form1.sg.colcount-1 do
  begin
   tmp:=form1.sg.cells[i,j];
   if (tmp='') or (tmp=' ') then tmp:='<BR>';
   if (i=0) and (j>0) then result:=result+'<TD><P ALIGN=LEFT><A HREF="https://www.huuto.net/kohteet/'+tmp+'">'+tmp+'</A></P></TD>'#13#10 else result:=result+'<TD><P ALIGN=LEFT>'+tmp+'</P></TD>'+#13#10;
  end;
  result:=result+'</TR>'+#13#10;
 end;
 result:=result+'</TABLE>'+#13#10+'</BODY>'+#13#10+'</HTML>'+#13#10;
end;

procedure tallennaHTML(FileName: string);
var f: textfile;
begin
 if ansilowercase(ExtractFileExt(FileName))<>'.html' then FileName:=FileName+'.html';
 AssignFile(F, FileName);
 Rewrite(F);
 Writeln(F, CreateHTML);
 Closefile(f);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 if savedialog1.execute then
 begin
  tallennaHTML(savedialog1.filename);
   if MessageDlg('Avaa tallennettu HTML selaimessa?', mtCustom, [mbYes,mbNo], 0)=idYes then
    avaalinkki('file:///'+savedialog1.filename);
 end;
end;

procedure TForm1.categoryidExit(Sender: TObject);
begin
 if categoryid.text<>'' then
  if kokonaisluvuksi(categoryid.text)<1 then
  begin
   categoryid.Text:='';
   showmessage('Osaston ID täytyy olla luku! (Tyhjäkenttä = kaikki osastot)');
  end;
end;

end.
